'#######################################################################'
' 	header.inc
'#######################################################################'
CON


' Ray, Peter, this little 'Load new ROM' routine rewrites the built-in
' ..16KB ROM with what is being assembled into $FC000..$FFFFF. After
' ..running it, you'll have a new ROM. To update the ROM image again,
' ..you'll need to power-cycle the FPGA board to get it to reload the
' ..original image which permits loading the whole 1024KB again.


{{ *********************** CHANGELOG **************************

'' RR20180512 v134a     Combine: ROM_Booter v33d, LSD_v133i, SD2_133jx, TAQOZ BOOTROM(7)
'' CG20180513     c     Update booter
'' RR20180513     c_001 Use booter's ao baud value for Monitor
''                  002 Disable interrupts and smart pins on P0 & P1, but don't stop uart
''            v134d
''                ef    Cmd_G coginit if addr $FC000, clockmax=200MHz, add nops/waitx to sendrecv
'' may want to change the SD fail destination???
PJ20180514 V134e        Implement buffered serial interrupts
                        ^D from TAQOZ switches to DEBUGGER
                        Add LF to LMM DEBUGGER (CRLF is standard line ending)
'' RR20180515 v135b     Add LF in other places; SD cogstop on failure
''                cd    Add load SD file "R"UN; SDinit to check for pullup
''                e     use "." in R<filename> as 8.3; add hubset #1 before cogstop
''                f     if Sd fails, jmp to shut_down in booter, now does cogid/cogstop
''                      parse R<filename>
''                g     add Chip's latest booter
''                h     Chip's latest; rearrange; remove delay1ms in serialinit & taqoz

PBJ180516 v136          Adding in high level SD support, not complete but has virtual SD memory layer.
                        Can load in full version of Tachyon with SD support using Ray's SD loader
                        TAQOZ will reboot if four ESCs are entered in sequence (usually I use break detect)

BIG BUG NOTICE!!!       SD fail should not stop cog as application may be on Flash - Check Flash before SD

'' RR20180516 v136c     fix <lf> in _HubRxString; push/pop around pa use in _SDcard_Init; reset at _start_sdcard ???
'' RR20180517 v136d     move and fname+2 ##$00FFFFFF from _Run_SDfile to search_dir
''                      use _str_hdg in _HubList (and for TAQOZ)
''                      remove reset_pins call in _Start_SDcard
''                e     _str_hdg add _str_dash; delay before calling taqoz
''                f     _HubList extra space ea 4 bytes
'' RR20180519 v136m     combine ROM_Booter_base_v32g; if SD fails boot,jmp #try_serial; Peter to add latest TAQOZ
''                      _str_hdg has dump header
''                +     tweek for P2ASM compiler; alignl long alignment after _str_hdg; _parsehex skip "_"

		138PBJ	Combine 137PBJ
                   a    remove delay1ms before monitor calls taqoz; jmp to _Enter_TAQOZ; remove _str_hdg

Need to:	Cmd_G   use hubset ##$1000_0000 for FC000  +delay1ms           (done)
			Taqoz to monitor needs to shutdown cogs
			Monitor to taqoz calls entry_taqoz and no 1ms delay    (done)
			reset_booter ???                                        ????
			Command9 needs to respect lmm_bufad not ##_HUBBUF ???
			_HUBBUF use ROM (FC000 ???)                            (done)
		Cmd_X	hex mode monitor/list option                           (done) "X"
			remove heading                                         (done)
			SD add write sector ???                                        no space!
			monitor <cr> to repeat list                            (done)
			<esc> on its own???
'' RR20180520   138b    command8 reply1=05 missing wz
''                      LL command replaces X                                  (done)
''                 c    add write_sector, command24, writeblock                 not verified!!
''                      overflowed ROM so use $FC000 for _HUBBUF
''                 d    try <cr> to repeat list for next addr
''                      make G a call instead of a jump
''                 e    tweeks to SD
''                      comment out write sd
''                      cmd_r result "="/"!"for passed/failed
''                 f    mod _start/load/run_SDcard
''                      ##hubdata use _hubdata
'' RR20180524   139     include ROM_Booter_base_138f.spin2  & RR139a (X<fname>)
''              139C    w Chip pasted code
''-----------------------------------------------------------------------------
''              140_a   List uses xxxxx: was xxxxx-
''                      R<filename> & L<fileanem>, List L[L] --> M[L]
''                 _e   List xxxxx- does not require L/M
''                 _f   use decod for PTN_SECCLU (needs TAQOZ 140e !!!)
''                 _g   add TAQOZ 140F
''                 _gx  remove unused labels fail etc
''                 _hx  reorg SD routines
'' RR20180526   140i    proposed final SD & Monitor
''                 k    fix SD timeout for dead/missing SD card w pullup. CMD0=10ms@35MHz
'' RR20180527  v141     proposed final SD & Monitor
'' PBJ20180527		Added SD and FAT32 routines
**************************************************************** }}
