TAQOZ

IFDEF *MEDIA*
	tim org
	FORGET *MEDIA*
}


pub *MEDIA*	PRINT" TAQOZ INTERACTIVE MEDIA - AUDIO, TEXT, IMAGE & VIDEO DRIVERS 200403-1200 " ;


		*** VIDEO ***


0 bytes tim

public

\ $0003_4600	:= BMP			--- BMP HEADER HEADER 256 bytes , then PAL 1024 bytes, then SCR

pub vint	BMP ;
\ BMP 		:= vint			--- intensity current (luma)
\ BMP 2 +		:= scrptr
\ BMP 4 +		:= hcnt			--- line counter advances every horz syn 0..479
\ BMP 6 +		:= vcnt			--- frame counter advances every vert syn 0..59
pub hcnt	BMP 4 + ;
pub vcnt	BMP 6 + ;


	*** VIDEO PARAMETER ACCESS ***

( @VGA = 4* $28 @ + )
pub V! ( l reg -- )		@VGA ! ;
pub VW! ( w reg -- )	@VGA W! ;
pub V@ ( reg -- l )		@VGA @ ;
pub VW@ ( reg -- w )	@VGA W@ ;

	*** VIDEO PARAMETER "CONSTANTS" ***

pub cols ( -- n )	1 V@ ;
pub rows ( -- n )	2 V@ ;
\ 1920		:= cols
\ 1080		:= rows

pub PAL ( -- addr )	6 V@ ;
pub SCR				7 V@ ;

pub BPP@			11 V@ ;
pub BPP ( bits -- )	11 V! ; \ ' BPP@ C! ;

	*** VIDEO TIMING ROUTINES ***

pub V/			3 V@ U/ 1 MAX ;

pub VRES ( x y scale -- )
	3 @VGA C!					--- FP,SY,BP,DIV
	2 V!  \ AT rows 2+ W!
	1 V!  \ AT cols 2+ W!
	BMP $100 + 6 V!
	BMP $500 + 7 V!
	;

pub VCLK ( freq --- )				V/ 4 V! ;
pub HSYN ( front width back -- )	V/ 10 VW! V/ 9 VW! V/ 8 VW! ;

{ P2B
0111 dddd eppp 001a   bbbb     RFLONG -> 32 x 1-bit LUT         32 out   %PONMLKJI_HGFEDCBA_ponmlkji_hgfedcba
0111 dddd eppp 010a   bbbb     RFLONG -> 16 x 2-bit LUT         32 out   %PONMLKJI_HGFEDCBA_ponmlkji_hgfedcba
0111 dddd eppp 011a   bbbb     RFLONG ->  8 x 4-bit LUT         32 out   %PONMLKJI_HGFEDCBA_ponmlkji_hgfedcba
0111 dddd eppp 1000   bbbb     RFLONG ->  4 x 8-bit LUT         32 out   %PONMLKJI_HGFEDCBA_ponmlkji_hgfedcba
}
{	TAQOZ# .VGA ---
 1 COLS   $0000_0280   640
 2 ROWS   $0000_01E0   480
 3 FSBD   $0130_6010   19947536
 4 freq   $0180_23D8   25175000
 5 $nco   $101C_AC08   270314504
 6 $PAL   $0003_3200   209408
 7 $SCR   $0003_3600   210432
 8 bSYN   $7F01_0037   2130772023
 9 SYNC   $7F01_0014   2130771988
10 bVIS   $7F01_006E   2130772078
11 BPP    $0000_0008   8
12 sVIS   $7F01_0000   2130771968
13 sRF    $7F08_0000   2131230720
14 B/L    $0000_0280   640
15 HDAC   $0016_0740   1443648
16 VDAC   $0017_0740   1509184  ok
}

0 TABLE vms $02 | $04 | $06 | $08 |

pub VSYN ( front width back -- )
	3 V@ 8<< OR 8<< OR 8<< OR 3 V!
pub !VGA --- Calculate NCO value from pixel frequency and start/restart VGA cog
	4 @VGA @ $4000.0000 CLKHZ 2/ U*/ 5 @VGA !
	13 V@ 24 >> $7F =
	  IF BPP@ >| vms + C@ 16 << $7F000000 + 13 V! THEN
	0 @VGA 7 COGINIT
	;

--- PATCH P2 CLOCK SPEED so it can also change the VGA speed
AT !VGA   AT !CLKHZ 2+ W!



{ VREGS
' 01 '
_hpixels	long	640
_vlines		long 	480
' 03 			FP,SY,BP,DIV
v_bs		byte	16,96,48,1	'5,5,20,2
' 04 '
_fpix		long	fpixn			' pixel frequency'
_fset		long	round(fset)		' pixel nco value'
_palette	long 	bmporg+$100		' address of palette (normally $FC00)'
_screen		long	bmporg+$500		' address of screen (normally $10000)'
' 08  		 $7F01 = output X3, X2, X1, X0 on all four DAC channels'
m_bs		long	$7F010000+55		'before sync  <long> 32-bit immediate
m_sn		long	$7F010000+20		'sync
m_bv		long	$7F010000+110		'before visible
' 11 '
bpp		long	8
'*1 note: The pixel parameter is calculated and added during init'
' 12			'%0111_0001_eppp_xxxx   <long>    32-bit immediate              $xxxxxxxx
m_vi		long	$7F01_0000		' *1
' 13 			%0111_1000_eppp_bbbb        -    8-bit RFLONG LUT              $xxxxxxxx
m_rf		long	$7F08_0000		' *1
' 14 '
_hbytes		long	640
dacmode_s       long    %0000_0000_000_1011000000000_01_00000_0+vgacog<<8         'hsync is 123-ohm, 3.3V
dacmode_c       long    %0000_0000_000_1011100000000_01_00000_0+vgacog<<8         'R/G/B are 75-ohm, 2.0V


}

pub .VGA		1 16 ADO CRLF I 2 U.R SPACE " COLSROWSFSBDfreq$nco$PAL$SCRbSYNSYNCbVISBPP sVISsRF B/L HDACVDAC" I 1- 4* + 4 CTYPE 3 SPACES I V@ DUP .L 3 SPACES . LOOP ;

pub V/2			1 V@ 2/ 2 V@ 2/ 3 V@ 2* VRES			8 VW@ 9 VW@ 10 VW@ HSYN !VGA ;

\ !VGA
	*** VIDEO TIMING MODES ***

( 4:3 v MODES )

pub 480v		640 480 1 : V25 VRES 25,175,000 VCLK		16 96 48 HSYN 10 2 31 VSYN ;
pub 240v		320 240 2 V25 ;
pub 120v		160 120 4 V25 ;

pub 600v		800 600 1 : V40 8 BPP VRES 40,000,000 VCLK 	40 128 88 HSYN 1 4 23 VSYN ;
pub 300v		400 300 2 V40 ;

pub 768v		1024 768 1 : V65 VRES 65,000,000 VCLK		24 136 160 HSYN 3 6 29 VSYN ;
pub 384v		512 384 2 V65 ;

( 16:9 p MODES )

pub 720p		1280 720 1 : V74 ( 8 BPP ) VRES 74,250,000 VCLK 	72 80 216 HSYN 3 5 22 VSYN  ;
pub 360p		640 360 2 V74 ;
pub 180p		320 180 4 V74 ;
pub 144p		256 144 5 V74 ;
\ pub 90p			160 90 8 V74 ;

--- 1080p x1bpp
pub 1080p		1 BPP 	1920 1080 1 : V148 VRES 148,500,000 VCLK 	88 44 148 HSYN 4 5 36 VSYN PAL ~~ PAL 4+ ~ ;
pub 540p	 	960 540 2 V148 ;


pub 384p		684 384 2 VRES 85,860,000 VCLK		72 144 216 HSYN 1 3 23 VSYN ;
pub 768p		1368 768 1 VRES 85,860,000 VCLK		72 144 216 HSYN 1 3 23 VSYN ;
pub 900p		1440 900 1 VRES 106,470,000 VCLK	80 152 232 HSYN 1 3 28 VSYN ;



pub SETBMP ( addr -- )	' BMP 2+ ! 8 BPP 360p !VGA ;




pub scrsz ( --- bytes )		cols rows * 3 >> BPP@ * ;
pub rm				cols 1- ;		--- right margin


private

pub PEN ( color -- )		>!
pri PEN@ ( -- color )		0 ;

pub PAPER ( color -- )		>!
pri PAPER@ ( -- color )		0 PEN@ 8<< + ;
pub P&P ( pen paper -- )	PAPER PEN ;

public
--- colors when palette is initialized
0		:= black
$E0		:= red
$1C		:= green
$F8		:= yellow
$0E		:= blue
$1F		:= cyan
$E3		:= magenta
$FF		:= white
$25		:= coal
$49		:= gray
$65		:= brown

pub PLAIN			white black P&P ;
pub REVERSE			PEN@ PAPER@ PEN PAPER ;

$170740		:= vgadac	--- VGA DAC SMARTPIN MODE
pub SCREEN ( on/off -- )	0 PIN DUP IF DROP vgadac THEN WRPIN ;

pri RGB> ( rgb -- r g b )	DUP 16>> >B OVER 8>> >B ROT >B ;
pri >RGB ( r g b -- rgb )	ROT 8<< ROT + 8<< + ;

pri !COL	>> 7 AND 36 W* ;

0 TABLE PAL1	-1 , 0 ,

0 TABLE PAL2	0 , $FF , $FF00 , $FF0000 ,

pri !PAL
	BPP@ 1 = IF PAL1 PAL 8 CMOVE EXIT THEN
	BPP@ 2 = IF PAL2 PAL 16 CMOVE EXIT THEN
\	BPP@ 4 = IF PAL4 PAL 64 CMOVE EXIT THEN
	256 0 DO
	  I 5 !COL
	  I 2 !COL
	  I 3 AND 84 W* >RGB
	  I 4* PAL + !
	LOOP
	;


( VGA text color schemes )
pub -MAC				!PAL black white P&P ;
pub -TERM				!PAL green 4 P&P ;
pub -C64				!PAL white blue P&P ;
pub -MONO				!PAL white black P&P ;

pub -VGA				8 BPP 480v -TERM ;



{
0 TABLE xterms ( imported from jonasjecek )
$000000 , $800000 , $008000 , $808000 , $000080 , $800080 , $008080 , $C0C0C0 ,
$808080 , $FF0000 , $00FF00 , $FFFF00 , $0000FF , $FF00FF , $00FFFF , $FFFFFF ,
$000000 , $00005F , $000087 , $0000AF , $0000D7 , $0000FF , $005F00 , $005F5F ,
$005F87 , $005FAF , $005FD7 , $005FFF , $008700 , $00875F , $008787 , $0087AF ,
$0087D7 , $0087FF , $00AF00 , $00AF5F , $00AF87 , $00AFAF , $00AFD7 , $00AFFF ,
$00D700 , $00D75F , $00D787 , $00D7AF , $00D7D7 , $00D7FF , $00FF00 , $00FF5F ,
$00FF87 , $00FFAF , $00FFD7 , $00FFFF , $5F0000 , $5F005F , $5F0087 , $5F00AF ,
$5F00D7 , $5F00FF , $5F5F00 , $5F5F5F , $5F5F87 , $5F5FAF , $5F5FD7 , $5F5FFF ,
$5F8700 , $5F875F , $5F8787 , $5F87AF , $5F87D7 , $5F87FF , $5FAF00 , $5FAF5F ,
$5FAF87 , $5FAFAF , $5FAFD7 , $5FAFFF , $5FD700 , $5FD75F , $5FD787 , $5FD7AF ,
$5FD7D7 , $5FD7FF , $5FFF00 , $5FFF5F , $5FFF87 , $5FFFAF , $5FFFD7 , $5FFFFF ,
$870000 , $87005F , $870087 , $8700AF , $8700D7 , $8700FF , $875F00 , $875F5F ,
$875F87 , $875FAF , $875FD7 , $875FFF , $878700 , $87875F , $878787 , $8787AF ,
$8787D7 , $8787FF , $87AF00 , $87AF5F , $87AF87 , $87AFAF , $87AFD7 , $87AFFF ,
$87D700 , $87D75F , $87D787 , $87D7AF , $87D7D7 , $87D7FF , $87FF00 , $87FF5F ,
$87FF87 , $87FFAF , $87FFD7 , $87FFFF , $AF0000 , $AF005F , $AF0087 , $AF00AF ,
$AF00D7 , $AF00FF , $AF5F00 , $AF5F5F , $AF5F87 , $AF5FAF , $AF5FD7 , $AF5FFF ,
$AF8700 , $AF875F , $AF8787 , $AF87AF , $AF87D7 , $AF87FF , $AFAF00 , $AFAF5F ,
$AFAF87 , $AFAFAF , $AFAFD7 , $AFAFFF , $AFD700 , $AFD75F , $AFD787 , $AFD7AF ,
$AFD7D7 , $AFD7FF , $AFFF00 , $AFFF5F , $AFFF87 , $AFFFAF , $AFFFD7 , $AFFFFF ,
$D70000 , $D7005F , $D70087 , $D700AF , $D700D7 , $D700FF , $D75F00 , $D75F5F ,
$D75F87 , $D75FAF , $D75FD7 , $D75FFF , $D78700 , $D7875F , $D78787 , $D787AF ,
$D787D7 , $D787FF , $D7AF00 , $D7AF5F , $D7AF87 , $D7AFAF , $D7AFD7 , $D7AFFF ,
$D7D700 , $D7D75F , $D7D787 , $D7D7AF , $D7D7D7 , $D7D7FF , $D7FF00 , $D7FF5F ,
$D7FF87 , $D7FFAF , $D7FFD7 , $D7FFFF , $FF0000 , $FF005F , $FF0087 , $FF00AF ,
$FF00D7 , $FF00FF , $FF5F00 , $FF5F5F , $FF5F87 , $FF5FAF , $FF5FD7 , $FF5FFF ,
$FF8700 , $FF875F , $FF8787 , $FF87AF , $FF87D7 , $FF87FF , $FFAF00 , $FFAF5F ,
$FFAF87 , $FFAFAF , $FFAFD7 , $FFAFFF , $FFD700 , $FFD75F , $FFD787 , $FFD7AF ,
$FFD7D7 , $FFD7FF , $FFFF00 , $FFFF5F , $FFFF87 , $FFFFAF , $FFFFD7 , $FFFFFF ,
$080808 , $121212 , $1C1C1C , $262626 , $303030 , $3A3A3A , $444444 , $4E4E4E ,
$585858 , $626262 , $6C6C6C , $767676 , $808080 , $8A8A8A , $949494 , $9E9E9E ,
$A8A8A8 , $B2B2B2 , $BCBCBC , $C6C6C6 , $D0D0D0 , $DADADA , $E4E4E4 , $EEEEEE ,

pub -XTERM	xterms PALETTE $400 CMOVE ;
}


	*** LINE DRAWING ***

private
word _x			--- graphics x
word _x1		--- backup of initial _x
word _y			--- graphics y
word _y1		--- backup of inital y

word width
word height

long scr*

--- set graphics origin and width and height
pub x			DUP _x W! _x1 W! ;
pub y			DUP _y W! _y1 W! ;
pub w			width W! ;
pub h			height W! ;

pri X@			_x W@ ;
pri Y@			_y W@ ;


pri XY@!		X@ Y@
pri XY!			_y1 W! _x1 W! ;
pri !XY			_x1 W@ _x W! _y1 W@ _y W! ;
pri X+!			_x W+! X@ cols => 0EXIT _x W~ _y W++ ;
pri Y+!			_y W+! Y@ rows => 0EXIT _y W~ ;

pri CENTER		cols 2/ rows 2/
pri @XY			y x ;

long tex 	tex ~~

OFF LISTING
{
 ( pen x y ) cols W* 3 >> SCR + OVER 3 >> + SWAP 7 AND |< ( pen ptr mask ) : P: ROT IF OVER C@ OR ELSE OVER C@ SWAP ANDN THEN SWAP C!
  0 100 100 LAP PLOT1 LAP .LAP --- 128 cycles= 376ns @340MHz ok
}
--- ( pen x y --  ) '
code PLOT1
	rdword	xx,#@cols 2+
	shr	xx,#3
	mul	a,xx		' a = cols W* >> 3 '
	rdlong	yy,#@SCR 2+
	add	a,yy
	mov	xx,b		' x '
	shr	xx,#3		' x >>3'
	add	a,xx		' a = scrptr
	rdbyte	xx,a		' read byte'
	and	b,#7		' bit position in byte '
	mov	c,c wz
 	bitnz	xx,b
 	wrbyte	xx,a
 	3DROP;
	end

--- 0 110 110 LAP PLOT LAP .LAP --- 464 cycles= 1,364ns @340MHz ok
\ cols W* + SCR + DUP scr* ! C!
code PLOT8 ' ( pen x y -- )'
	rdword	xx,#@cols 2+
	mul		a,xx		' y = y*cols'
	add		b,a			' x = x+y '
	rdlong	a,#@SCR 2+
	add		b,a			' scr + '
	wrlong	b,#scr*		' '
 	wrbyte	c,b
	3DROP;
	end


{
PIXEL!	write color to pixel at XY - do not change XY - update scr* pointer
0 LAP PIXEL! LAP .LAP --- 1,840 cycles= 5,411ns @340MHz ok
}
pub PIXEL! ( pen -- )
	X@ Y@
pub PLOT ( pen x y -- )
---	1 BPP PLOT --- 0 100 100 LAP PLOT LAP .LAP --- 568 cycles= 1,670ns @340MHz ok
	BPP@ 1 = IF PLOT1 EXIT THEN
\	BPP@ 1 = IF cols W* 3 >> SCR + OVER 3 >> + SWAP 7 AND |< ( pen ptr mask ) : P: ROT IF OVER C@ OR ELSE OVER C@ SWAP ANDN THEN SWAP C! EXIT THEN

---		    calc line addr                    byte addr                  2-bit mask
\	BPP@ 2 = IF cols W* 2 >> SCR + ( pen x yadr ) OVER 2 >> + ( pen x addr ) 3 ROT 3 AND 2* <<  ( pen ptr mask ) OVER C@ OVER ANDN ( pen ptr mask data&m ) EXIT THEN
---	8 BPP PLOT --- 0 100 100 LAP PLOT LAP .LAP --- 1,000 cycles= 2,941ns @340MHz ok
\  	 cols W* + SCR + DUP scr* ! C!
	 PLOT8
	;


byte _paper1
byte _pen1

pri >PEN		PEN@ _pen1 C! PEN ;
pri PEN>		_pen1 C@ PEN ;



--- Top Left
pri TL			0 0 @XY ;
--- Top Right
pri TR			cols 1- 0 @XY ;
--- Bottom Left
pri BL			0 rows 1- @XY ;
--- Bottom Right
pri BR			cols 1- 0 @XY ;


{

\ -------------------------------------------------------------
\  Bresenham line
\ -------------------------------------------------------------

0 variable line-x1   0 variable line-y1
0 variable line-sx   0 variable line-sy
0 variable line-dx   0 variable line-dy
0 variable line-err

: line ( x0 y0 x1 y1 -- )

  line-y1 ! line-x1 !

  over line-x1 @ -   dup 0< if 1 else -1 then line-sx !   abs        line-dx !
  dup  line-y1 @ -   dup 0< if 1 else -1 then line-sy !   abs negate line-dy !
  line-dx @ line-dy @ + line-err !

  begin
    2dup putpixel
    2dup line-x1 @ line-y1 @ d<>
  while
    line-err @ 2* >r
    r@ line-dy @ > if line-dy @ line-err +! swap line-sx @ + swap then
    r> line-dx @ < if line-dx @ line-err +!      line-sy @ +      then
  repeat
  2drop
;

\ -------------------------------------------------------------
\  Bresenham ellipse
\ -------------------------------------------------------------

0 variable ellipse-xm   0 variable ellipse-ym
0 variable ellipse-dx   0 variable ellipse-dy
0 variable ellipse-a    0 variable ellipse-b
0 variable ellipse-a^2  0 variable ellipse-b^2
0 variable ellipse-err

: ellipse-putpixel ( y x -- ) ellipse-xm @ + swap ellipse-ym @ + putpixel ;

: ellipse-step ( -- )
    ellipse-dy @        ellipse-dx @        ellipse-putpixel
    ellipse-dy @ negate ellipse-dx @        ellipse-putpixel
    ellipse-dy @ negate ellipse-dx @ negate ellipse-putpixel
    ellipse-dy @        ellipse-dx @ negate ellipse-putpixel

    ellipse-err @ 2* >r
    r@  ellipse-dx @ 2* 1+ ellipse-b^2 @ *        < if  1 ellipse-dx +! ellipse-dx @ 2* 1+ ellipse-b^2 @ *        ellipse-err +! then
    r>  ellipse-dy @ 2* 1- ellipse-a^2 @ * negate > if -1 ellipse-dy +! ellipse-dy @ 2* 1+ ellipse-a^2 @ * negate ellipse-err +! then
;


: ellipse ( xm ym a b -- )

  0 ellipse-dx ! dup ellipse-dy !

  dup ellipse-b ! dup * ellipse-b^2 !
  dup ellipse-a ! dup * ellipse-a^2 !
  ellipse-ym ! ellipse-xm !

  ellipse-b^2 @ ellipse-b @ 2* 1- ellipse-a^2 @ * - ellipse-err !

  begin
    ellipse-step
    ellipse-dy @ 0<
  until

  ellipse-dx @
  begin
    1+
    dup ellipse-a @ <
  while
    0 over        ellipse-putpixel
    0 over negate ellipse-putpixel
  repeat
  drop
;

: circle ( xm ym r -- ) dup ellipse ;

}


private
word X2
word Y2
word Y+-
word X+-

--- simple line draw in 1st octant - continue to draw a line to these coordinates
pub LINETO ( x2 y2 -- )
	Y2 W! X2 W!
	1 Y2 W@ Y@ < ?NEGATE Y+- W!
	1 X2 W@ X@ < ?NEGATE X+- W!
	Y2 W@ Y@ - ( dy )
	X2 W@ X@ - ( dy dx )
	OVER 2* OVER - ( dy dx d )
	BEGIN
	  X@ X2 W@ <=
	WHILE
	  PEN@ PIXEL!
	  X+- W@ X+!
	  DUP 0< IF 3RD 2* + ELSE 3RD 3RD - 2* + Y+- W@ Y+! THEN
	REPEAT
	3DROP
	;

pub HLINE ( -- )
	BPP@ 1 =
	IF X@ width W@ ADO PEN@ I _y W@ PLOT  LOOP
	ELSE width W@ PEN@ PIXEL! scr* @ DUP 1+ ROT 1- CMOVE THEN
	;

pub VLINE ( -- )		height W@ FOR PEN@ PIXEL! 1 Y+! NEXT !XY ;


pub RECT 	  		HLINE VLINE width W@ 1- X+! VLINE !XY height W@ 1- Y+! HLINE !XY ;
--- draw a thick frame
pub FRAME ( thick -- )		FOR RECT _x1 W++ _y1 W++ !XY width W@ 2- w height W@ 2- h NEXT DROP ;
\ pub PANEL ( color -- ) 		>PEN height W@ FOR _x1 W@ _x W! HLINE 1 Y+! NEXT PEN> ;
pub PANEL ( -- ) 		height W@ FOR _x1 W@ _x W! HLINE 1 Y+! NEXT ;

pub BOX ( pattern depth -- )	FOR X@ 1+ x Y@ 1+ y RECT NEXT PANEL ;

{
: DEMO
100 w 100 h  50 50 ADO I 1& PEN  I x I y RECT LOOP
 ;


: PANEL ( width height color -- ) 	>PEN FOR _x1 W@ _x W! DUP HLINE 1 Y+! NEXT DROP PEN> ;

40 x 40 y 200 w 100 h red panel

}

\ : FRAMED ( width height -- )	$FF PEN 2DUP PANEL $20 PEN !XY 10 _x1 W+! 10 _y W+! 20 - SWAP 20 - SWAP PANEL ;

{
: GDEMO		80 1 DO I 2* DUP x y i 4* DUP w h I 3 W*  PANEL 4 +LOOP ;
\ 80 1 DO I 4* x I 2* y i 4* w I 4* h I 3 W*  PANEL 4 +LOOP
: HVFLIP	SCR DUP scrsz + 1- scrsz 2/
: XFLIP		FOR OVER C@ OVER C@ 4TH C! OVER C! 1- b++ NEXT 2DROP ;
: HFLIP		rows 0 DO I cols W* SCR + DUP cols 1- + cols 2/ XFLIP LOOP ;
}




\ : CS
pub CLRSCR	PAPER@
pub VFILL 	SCR scrsz ROT FILL !PAL 0 >!
pri lm		0 ; --- left margin


pub LUMA ( % -- )		vint C! ;

pub SYNCH			1
pub FRAMES ( cnt -- )		vcnt W@ + >W BEGIN DUP vcnt W@ = UNTIL DROP ;
pub BLANK			0 LUMA ;
pub SHOW			SYNCH vint 1+ C@ 60 MAX LUMA ;




{ display palette colors
: XX 	CLRSCR SCR scrsz ROT FILL ;
CLRSCR 512 0 DO I 0 @XY I 2/ PEN 10 VLINE LOOP
CLRSCR 256 0 DO 0 I @XY I PEN 640 HLINE LOOP
CLRSCR 256 0 DO I >N 40 * I 4 >> 30 * @XY I PEN 40 30 PANEL LOOP
}

		*** BMP VIEWER ***

pub *BMP*	PRINT" BMP FILE VIEWER 190800-0000" ;
{
00000: 4D42 B47A 0004 0000  0000 047A 0000 006C     'BMz.......z...l.'
00010: 0000 0280 0000 01E0  0000 0001 0008 0000     '................'
00020: 0000 B000 0004 0B13  0000 0B13 0000 0100     '................'
00030: 0000 0100 0000 4742  7352 0000 0000 0000     '......BGRs......'
00040: 0000 0000 0000 0000  0000 0000 0000 0000     '................'
00050: 0000 0000 0000 0000  0000 0000 0000 0000     '................'
00060: 0000 0000 0000 0000  0000 0002 0000 0000     '................'
00070: 0000 0000 0000 0000  0000 0C0C 000C 5028     '..............(P' ok

BMP FILE FORMAT
0		BM	SIGNATURE
2		$04B47A	FILE SIZE	(308,346)
6		$0000	RES1
8		$0000	RES2
$0A		$047A	PIXELARRAY OFFSET

$0E		DIB HEADER

$12 4		$0280 HORZ RES
$16 4		$01E0 VERT RES
$1C 		8 bits
$32 2		colors
}

--- flip image vertically - used for inverted BMP images
pub VFLIP
	BLANK
	SCR DUP rows 1- cols W* +
	BEGIN
	  DUP SDBUF cols 4/ LMOVE 2DUP cols 4/ LMOVE SDBUF 3RD cols 4/ LMOVE
	  cols - SWAP cols + SWAP
	  2DUP >
	UNTIL
	2DROP
	SHOW
	;


private 14 bytes V$

pub OPEN.BMP$ ( str -- sector )
	DUP UPPER$ V$ $!
	V$ " .BMP" $+ FOPEN$ @FILE \ ?DUP 0EXIT
	;

pre VIEW ( <name> --- )
	GET$
pub VIEW$ ( str -- )
	OPEN.BMP$
--- View the BMP file at the starting sector
pub VIEWSEC ( sector -- )
---	read file header and align file palette to memory palette then read all
	?DUP 0EXIT
	  CLRSCR DUP OPEN-SECTOR
---	  locate offset of data (assume palette=1k) and read directly into screen memory
	  PAL 10 SDW@ $400 - - scrsz 1535 + ( $400 + 511 + ) BLANK SDRDS
---	 read colors used and adjust palette offset if needed if not 256
	  $32 SDW@ IF 256 $32 SDW@ -
	    ?DUP IF 4* PAL OVER + PAL ROT 1024 SWAP - CMOVE THEN
	    THEN
--- 	  flip the inverted bmp image and set default video intensity
	  VFLIP	90 LUMA
	;

{  *** BMP HEADER ***  54 BYTES

00 	0 	2 bytes 	BM    Windows 3.1x, 95, NT, ... etc.
02 	2 	4 bytes 	The size of the BMP file in bytes
06 	6 	2 bytes 	Reserved; actual value depends on the application that creates the image
08 	8 	2 bytes 	Reserved; actual value depends on the application that creates the image
0A 	10 	4 bytes 	The offset, i.e. starting address, of the byte where the bitmap image data (pixel array) can be found.
0E 	14 	4 	the size of this header (40 bytes)
12 	18 	4 	the bitmap width in pixels (signed integer)
16 	22 	4 	the bitmap height in pixels (signed integer)
1A 	26 	2 	the number of color planes (must be 1)
1C 	28 	2 	the number of bits per pixel, which is the color depth of the image. Typical values are 1, 4, 8, 16, 24 and 32.
1E 	30 	4 	the compression method being used. See the next table for a list of possible values
22 	34 	4 	the image size. This is the size of the raw bitmap data; a dummy 0 can be given for BI_RGB bitmaps.
26 	38 	4 	the horizontal resolution of the image. (pixel per metre, signed integer)
2A 	42 	4 	the vertical resolution of the image. (pixel per metre, signed integer)
2E 	46 	4 	the number of colors in the color palette, or 0 to default to 2n
32 	50 	4 	the number of important colors used, or 0 when every color is important; generally ignored


	   BM    ----SIZE---- -RES-  -RES- IMAGE-OFFSET HEADER-SIZE
0003_0086: 42 4D 7A B4  04 00 00 00  00 00 7A 04  00 00 6C 00     'BMz.......z...l.'
	   ----- ---WIDTH---- ---HEIGHT--- -PLN-  BITS  COMP
0003_0096: 00 00 80 02  00 00 E0 01  00 00 01 00  08 00 00 00     '................'
	         -IMAGE-SIZE- ---HPIX/M--- ---VPIX/M--- -COLORS-
0003_00A6: 00 00 00 B0  04 00 13 0B  00 00 13 0B  00 00 00 01     '................'
	   ----- -IMPORTANT--
0003_00B6: 00 00 00 01  00 00 42 47  52 73 00 00  00 00 00 00     '......BGRs......'
0003_00C6: 00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00     '................'
0003_00D6: 00 00 00 00  00 00 00 00  00 00 00 00  00 00 00 00     '................'
0003_00E6: 00 00 00 00  00 00 00 00  00 00 02 00  00 00 00 00     '................'
	                                   ---PALETTE-->
0003_00F6: 00 00 00 00  00 00 00 00  00 00 00 01  08 00 08 02     '................'
0003_0106: 05 00 09 01  0E 00 10 02  0B 00 17 01  0F 00 03 03     '................'
0003_0116: 12 00 02 05  0C 00 0E 02  14 00 08 05  19 00 00 07     '................'
0003_0126: 17 00 01 09  12 00 09 08  16 00 03 07  1C 00 0D 06     '................'
0003_0136: 1F 00 06 08  20 00 00 0C  1C 00 00 0C  20 00 0A 0A     '.... ....... ...'
0003_0146: 25 00 02 0C  23 00 12 09  28 00 04 0B  27 00 0F 0B     '%...#...(...'...'
0003_0156: 2B 00 0A 0C  2E 00 02 0E  2C 00 02 12  29 00 04 0F     '+.......,...)...'
0003_0166: 37 00 03 13  31 00 14 12  35 00 12 14  2F 00 0C 14     '7...1...5.../...'
0003_0176: 32 00 00 15  35 00 00 17  31 00 12 13  45 00 13 17     '2...5...1...E...' ok

}

BMP 134 +	:= BMPHDR

\ Create a BMP header table that is used to make a screen bmp into a file bmp '
0 TABLE BMPTBL
	$42 | $4D | 308346 , 0 , $047A ,
--- extended header
	$6C , cols , rows , 1 || 8 || 0 , scrsz ,
	2835 , 2835 , 256 , 256 ,
	\ " BGRs" @ ,


pre FBGRAB ( <name> )
---	allow a file to be created if it does not exsist
	308346 MAKE
pre FBSAVE
---	setup a simple BMP header in BMP display memory
	BMPTBL BMPHDR 52 CMOVE
---	open <name>       and save memory if valid
	[C] FOPEN @FILE IF VFLIP BMPHDR @FILE 308346 SDWRS VFLIP ELSE ."  NOT FOUND " THEN
	;
















word ao
{
: PLOTWAV	(  s -- )
	SCR 1+ SCR scrsz 2/ 2/ LMOVE
	SCR 639 + 480 640 * ADO 0 I C! 640 +LOOP
	137 U/ 640 W* 639 + SCR + $FF SWAP C! ;
	;

: T	BEGIN ao W@ PLOTWAV KEY UNTIL ;
}

word ax

\ SCR scrsz + cols ERASE
SCR scrsz cols - := scrbl

: PLOTWAV	(  s -- )
	SCR cols + SCR scrsz 2/ 2/ LMOVE
	DUP $8000 AND IF $FFFF0000 OR THEN
	40 / 320 + scrbl + $FF SWAP C!
\	ax W++ ax W@ 479 > IF 0 ax W! THEN
	;


pub WAVES	POLL: ao W@ PLOTWAV ;


pub MODULATE  POLL: ao W@ 16<< 22 SAR 120 + LUMA ;

( pub MODULATE  POLL: ao W@ 16 SHL 22 SAR 120 + vint C! ; )
\ : MODULATE	POLL: ao W@ ABS 128 + 8>> vint C! ;




{
: PLOTWAV	(  s -- )
	SCR ax W@ + 480 640 * ADO 0 I C! 640 +LOOP
	40 U/ 240 + 640 W* ax W@ + SCR + $FF SWAP C!
	ax W++ ax W@ 638 > IF 0 ax W! THEN
	;

: T	BEGIN ao W@ PLOTWAV KEY UNTIL ;
}



pub *WAVE*	PRINT" WAVE AUDIO FILE PLAYER 190800-0000" ;

		*** WAVE AUDIO ***

	( Ultra-simple non-streamer wave file audio player )

\ 30	:= LOUT	--- default audio out
\ 31	:= ROUT
6	:= LOUT	--- default audio out
7	:= ROUT


3072			:= wavblk#	--- size of each wave buffer (multiples of 512)

$7.B800			:= wavbuf	--- 18k available
wavbuf wavblk# +	:= wavbuf2

long wavsect		--- next sector to be read
long wavsz		--- total byte size of data
long samrate		--- sample rate in Hz
long _pitch		--- final playback sampling rate
byte wavflg		--- pause:3 play:2 buf2:1 buf1:0
pri *pause 	4 wavflg ;

byte rch		--- right channel I/O (but 0 = off)
byte lch		--- left channel I/O
byte vol/		--- volume control divider
byte vol*		--- volume control multipler


pub VOL ( mul/div -- )	vol/ W! ;

--- open the file with
pub OPEN-EXT$ (  file$ ext$ -- )
	?MOUNT \ ROOT
\	SWAP file$ $!	file$ SWAP $+
	$+ FOPEN$
	;

pub STOP
	wavsz ~ *pause CLR
	( !POLLS ) 1 COGSTOP 2 COGSTOP
	;
{
pri AOUT	C@ ?DUP IF PIN DUP WYPIN THEN ;

pub AUDIO ( dat -- )
\	vol* C@ * vol/ C@ /
	DUP ao W! $8000 +
	lch AOUT
	rch AOUT
	DROP WAITCT1
	;
}

--- note - this routine has fixed constants for audio output
CODE AUDIO_OUT
	DUP ao W!
	mov		xx,a
	add		a,#$8000
	subr	xx,#$8000
	wypin	a,#LOUT
	wypin	xx,#ROUT
	call	#\@WAITCT1
	DROP;
	end


{
--- testing differential audio to piezo transducer
CODE AUDIO1
	DUP ao W!
	ON LISTING
	mov		xx,a
	add		a,#$8000
	subr	xx,#$8000
	wypin	a,#LOUT
	wypin	xx,#ROUT
	call	#\@WAITCT1
	DROP;
	end

REVECTOR AUDIO AUDIO1


}
pub PLAYBUF ( buf -- )
	wavblk# ADO
	  BEGIN *pause SET? UNTIL		--- pause?
	  I W@ AUDIO_OUT -2 wavsz +!	--- output next sample
	2 +LOOP
	;

12 := dacbits

pub PLAY.TASK
	LOUT PIN dacbits DAC    ROUT PIN dacbits DAC
	$84 wavflg SET
	BEGIN
	  BEGIN wavsz @ UNTIL
	  BEGIN
	    CLKHZ _pitch @ U/ SETCT1
	    wavbuf PLAYBUF 1 wavflg CLR
	    wavbuf2 PLAYBUF 2 wavflg CLR
	    wavsz @ 2 <
	  UNTIL
	  wavsz ~
	AGAIN
	;


--- read a wav block into a buffer - 3.6ms @300MHz
pri GETWAV ( buf -- )
	wavsect @ SWAP wavblk# SDRDS wavblk# 9>> wavsect +!
	;

--- this routine needs to be polled at least every 40ms or so
--- fill the empty wave buffers from the file
pub ?WAVE --- POLLING METHOD
	wavsz @ 0EXIT
	8 wavflg SET? ?EXIT
---	if not empty	     fill a buffer and flag
	1 wavflg SET? NOT IF wavbuf GETWAV 1 wavflg SET THEN
	2 wavflg SET? NOT IF wavbuf2 GETWAV 2 wavflg SET THEN
	;

--- continue to fill the dual buffers from file as needed
pub WAVE.TASK
	BEGIN ?WAVE wavsz @ 0= UNTIL
	COGID COGSTOP
	;

---	setup and play file (starting sector)
pub PLAY# ( file -- )
---	verify file is open
	?DUP 0EXIT OPEN-SECTOR
---	verify it is a RIFF and a WAVE
	0 SD@ " RIFF" @ = 0EXIT
	8 SD@ " WAVE" @ = 0EXIT
---	ready to STOP amy current track & setup default l/r & vol
	STOP 	LOUT lch C! ROUT rch C! 	1:01 vol* W!
---	set sampling rate & set pitch
	24 SD@ DUP samrate ! _pitch !
---	scan chunks for data chunk          skip sub-chunk
	36 BEGIN DUP SD@ " data" @ <> WHILE 4+ DUP SD@ + 4+ REPEAT
---	read next long as data chunk size
	4+ DUP SD@
---  	mute header data (simplifies wave player software )
	4+ wavbuf ROT ERASE
---	now setup file sector pointer and kick off a wave buffer
	@FILE wavsect ! wavbuf GETWAV 	1 wavflg C!
	wavbuf2 wavblk# ERASE
---	now we can store the data chunk size (wavsz is also a flag)
	wavsz !
---	release SD I/O and let another cog read the sectors and feed the buffers
	SDCS FLOAT SDCK FLOAT SDDI FLOAT
--- 	player task runs in a cog constantly feeding the dac audio out
	AT PLAY.TASK 1 RUN
	;

--- 	CLI to PLAY <name>
pre PLAY ( <name> -- )
	GET$
--- 	play a WAV file by name
pub PLAY$ ( name$ -- )
	" .WAV" OPEN-EXT$
	@FILE ?DUP 0EXIT PLAY#
	AT ?WAVE +POLL
	;


--- verion of PLAY$ used by video player that polls wave buffers externally
pub TRACK$
	" .WAV" OPEN-EXT$
	@FILE PLAY#
	;


pub PAUSE
	*pause 2DUP SET? IF CLR ELSE SET THEN
	;

pub REW ( sec -- )
	NEGATE
pub FWD ( sec -- )
	_pitch @ 2* * DUP 9 SAR wavsect +! NEGATE wavsz +!
	;


pub PITCH ( +/-% -- )
	samrate @ SWAP 100 */ _pitch !
	;

long track
pub PLAYALL
	track ~
	POLL:
	wavsz @ ?EXIT
	CWD track @ GETDIR fname C@ 0= IF track ~ THEN
	fext @ " WAV " @ =
	IF OPENDIR @FILE PLAY# THEN
	track ++
	;

--- previous track
pub |<<		-2 track +!
--- next track
pub >>|		wavsz ~ ;

{ WAVE FORMAT
00000: 52 49 46 46  1C 3F DF 00  57 41 56 45  66 6D 74 20     'RIFF.?..WAVEfmt '
00010: 10 00 00 00  01 00 01 00  44 AC 00 00  88 58 01 00     '........D....X..'
00020: 02 00 10 00  64 61 74 61  00 3E DF 00  00 00 00 00     '....data.>......'
00030: 00 00 00 00  00 00 01 00  FE FF 02 00  FF FF 00 00     '................'
00040: 01 00 FF FF  00 00 01 00  FE FF 03 00  FD FF 02 00     '................'
00050: FF FF 00 00  01 00 FF FF  00 00 01 00  FE FF 02 00     '................'
00060: 00 00 FE FF  02 00 FF FF  00 00 01 00  FF FF 01 00     '................'
00070: FF FF 01 00  FF FF 01 00  FF FF 01 00  FF FF 01 00     '................'
00080: FF FF 01 00  FF FF 01 00  FF FF 02 00  FE FF 01 00     '................'
00090: FF FF 01 00  FF FF 02 00  FD FF 03 00  FC FF 05 00     '................'
000A0: FB FF 04 00  FD FF 02 00  FF FF 00 00  00 00 00 00     '................'
000B0: 00 00 01 00  FE FF 02 00  FE FF 01 00  00 00 00 00     '................'
000C0: 01 00 FE FF  02 00 FE FF  02 00 FF FF  01 00 FE FF     '................'
000D0: 03 00 FD FF  03 00 FE FF  00 00 02 00  FD FF 03 00     '................'
000E0: FE FF 01 00  00 00 FF FF  01 00 FF FF  02 00 FE FF     '................'
000F0: 01 00 FF FF  00 00 02 00  FE FF 01 00  00 00 FE FF     '................' ok
The canonical WAVE format starts with the RIFF header:

0         4   ChunkID          Contains the letters "RIFF" in ASCII form
                               (0x52494646 big-endian form).
4         4   ChunkSize        36 + SubChunk2Size, or more precisely:
                               4 + (8 + SubChunk1Size) + (8 + SubChunk2Size)
                               This is the size of the rest of the chunk
                               following this number.  This is the size of the
                               entire file in bytes minus 8 bytes for the
                               two fields not included in this count:
                               ChunkID and ChunkSize.
8         4   Format           Contains the letters "WAVE"
                               (0x57415645 big-endian form).

The "WAVE" format consists of two subchunks: "fmt " and "data":
The "fmt " subchunk describes the sound data's format:

12        4   Subchunk1ID      Contains the letters "fmt "
                               (0x666d7420 big-endian form).
16        4   Subchunk1Size    16 for PCM.  This is the size of the
                               rest of the Subchunk which follows this number.
20        2   AudioFormat      PCM = 1 (i.e. Linear quantization)
                               Values other than 1 indicate some
                               form of compression.
22        2   NumChannels      Mono = 1, Stereo = 2, etc.
24        4   SampleRate       8000, 44100, etc.
28        4   ByteRate         == SampleRate * NumChannels * BitsPerSample/8
32        2   BlockAlign       == NumChannels * BitsPerSample/8
                               The number of bytes for one sample including
                               all channels. I wonder what happens when
                               this number isn't an integer?
34        2   BitsPerSample    8 bits = 8, 16 bits = 16, etc.
          2   ExtraParamSize   if PCM, then doesn't exist
          X   ExtraParams      space for extra parameters

The "data" subchunk contains the size of the data and the actual sound:

36        4   Subchunk2ID      Contains the letters "data"
                               (0x64617461 big-endian form).
40        4   Subchunk2Size    == NumSamples * NumChannels * BitsPerSample/8
                               This is the number of bytes in the data.
                               You can also think of this as the size
                               of the read of the subchunk following this
                               number.
44        *   Data             The actual sound data.

FSIZE@		   14630692
TAQOZ# 4 SD@ . --- 14630684 ok
TAQOZ# 8 SD@ .L --- $4556_4157 ok
TAQOZ# 12 SD@ .L --- $2074_6D66 ok
TAQOZ# 16 SD@ .L --- $0000_0010 ok
TAQOZ# 20 SD@ .W --- $0001 ok
TAQOZ# 22 SD@ .W --- $0001 ok
TAQOZ# 24 SD@ . --- 44100 ok
TAQOZ# 28 SD@ . --- 88200 ok
TAQOZ# 32 SD@ .W --- $0002 ok
TAQOZ# 34 SD@ .W --- $0010 ok
TAQOZ# 36 SD@ .L --- $6174_6164 ok
TAQOZ# 40 SD@ . --- 14630400 ok

00000: 4952 4646 C6D4 00EA  4157 4556 6D66 2074     'RIFF....WAVEfmt '
00010: 0010 0000 0001 0001  AC44 0000 5888 0001     '........D....X..'
00020: 0002 0010 494C 5453  00A8 0000 4E49 4F46     '....LIST....INFO'
00030: 4149 5452 000B 0000  6542 206E 2045 694B     'IART....Ben E Ki'
00040: 676E 0000 4349 544D  0012 0000 6942 6C6C     'ng..ICMT....Bill'
00050: 6F62 7261 2064 6F54  2070 3031 0030 4349     'board Top 100.IC'
00060: 4452 0005 0000 3931  3136 0000 4749 524E     'RD....1961..IGNR'
00070: 0007 0000 6F54 2070  3034 0000 4E49 4D41     '....Top 40..INAM'
00080: 000C 0000 7453 6E61  2064 7942 4D20 0065     '....Stand By Me.'
00090: 5049 4452 001A 0000  6942 6C6C 6F62 7261     'IPRD....Billboar'
000A0: 2064 6F54 2070 3031  2030 666F 3120 3639     'd Top 100 of 196'
000B0: 0031 5049 5452 0003  0000 3235 0000 5349     '1.IPRT....52..IS'
000C0: 5446 000E 0000 614C  6676 3735 382E 2E33     'FT....Lavf57.83.'
000D0: 3031 0030 6164 6174  C600 00EA 0000 0000     '100.data........'

}







		*** BMP MOVIE SUPPORT ***

pub *BMV*	PRINT" BMV VIDEO PLAYER 190800-0000" ;

long vwin
long hwin

$20000 := BMVBUF
257 := YRES
320 := XRES



pub !WIN	160 120
pub SETWIN	vwin W! hwin W! ;

!WIN

long vbounce
long hbounce

pub BOUNCE	vbounce ! hbounce ! ;
0 0 BOUNCE


pub NEGATE!	DUP @ NEGATE SWAP ! ;
--- simple window bouncing
pub ?BOUNCE
	vbounce @ hbounce @ OR 0EXIT
	vbounce @ vwin W+! hbounce @ hwin W+!
	vwin W@ rows YRES - => IF vbounce NEGATE! THEN
	vwin W@ 1 < IF vbounce NEGATE! THEN
	hwin W@ cols XRES - => IF hbounce NEGATE! THEN
	hwin W@ 1 < IF hbounce NEGATE! THEN
	;



{  *** BMP HEADER ***  54 BYTES
---     BM   -SIZE-            PALETTE     HDSIZE
00000: 4D42 3036 0001 0000  0000 0436 0000 0028     'BM60......6...(.'
---         --WIDTH-- --HEIGHT-- PLNS BITS COMP
00010: 0000 0140 0000 00F0  0000 0001 0008 0000     '..@.............'
---         IMAGESIZE HPIXELS/M  VPIXELS/M  COLORS
00020: 0000 0000 0000 0B12  0000 0B12 0000 0000     '................'
}

byte wspd	--- video playback speed (in frames)
byte skips
long frame	--- current frame number

0 := BSECTS	--- runtime frame sector size

pub FRAME-		NEGATE
pub FRAME+		BSECTS * frame +! ;

{
code DWIDTH
' 3ms per frame QVGA-->VGA FULL-SCREEN upscaler -
' ( src scr --  src+640 scr )
			setq2	#32-1			' copy into LUT
			rdlong	lutfree,#l0
			jmp	#lutfree+$200		' and run

.l0			setq2	#80-1
			rdlong	srcbuf,b		' read all of source
'
			mov	r3,#srcbuf		' set lut src
			mov	r1,#lmbuf		' set lut dst

			rep	#18,#80
			rdlut	u,r3			' read 4 bytes of source
			add	r3,#1

			getbyte	X,u,#0		' get byte
			setbyte	X,u,#1		' double it up
			shr	u,#8			' next byte
			setbyte	X,u,#2		' set it
			setbyte	X,u,#3		' double it up
			wrlut	X,r1			' save in lut
			shr	u,#8
			add	r1,#1			' update dst ptr

			getbyte	X,u,#0		' get byte
			setbyte	X,u,#1		' double it up
			shr	u,#8			' next byte
			setbyte	X,u,#2		' set it
			setbyte	X,u,#3		' double it up
			wrlut	X,r1			' save in lut
			shr	u,#8
			add	r1,#1			' update dst ptr

			setq2	#160-1			' write out result to screen dst
			wrlong	lmbuf,a
			add	a,#640		' double lines as well'
			setq2	#160-1			' write out result to screen dst
			wrlong	lmbuf,a
		_ret_	add	a,#640
			end

}

pri VIEWP --- view frame palette and setup
---	find pixel offset
	BMVBUF DUP 10 + W@ + ( pixels )
---	copy preceding palette
	DUP $400 - PAL 256 LMOVE
---	locate end of inverted bmp frame
	YRES DUP XRES * ROT + SWAP ( srcend lines  )
	;

--- VIEW FULL SCREEN as doubled to 640x480
pub VIEWF --- view frame full-screen
	VIEWP ( srcend lines )
	SCR SWAP ( src dst lines )
---	 and read back line by line from end of frame (upside down)
---	double  src dst.......... upscale & double lines
	FOR DWIDTH SWAP XRES - SWAP NEXT 2DROP
	;

( 311,840 cycles= 1,039,466ns @300MHz ok )
--- VIEW NORMAL 320x240
pub VIEWN --- view frame normal size
	VIEWP ( srcend lines  )
---	 and read back line by line from end of frame (upside down)
---             ------destination------------------  80 longs
	FOR DUP SCR  vwin W@ I+ cols W* + hwin W@ +   80 LMOVE   XRES - NEXT DROP
\	0 DO DUP SCR I vwin W@ + cols W* + hwin W@ + 80 LMOVE XRES - LOOP DROP
	?BOUNCE
	;

--- VIEW HYBRID
pri VIEWH	VIEWF VIEWN  ;

--- view frame vector
pri VIEW-FRAME	VIEWN ;

16 bytes BMV$	--- name of bmv video file

pub LOAD-FRAME		frame @ BMVBUF BSECTS 9<< SDRDS ;




pub ?MEDIA-KEYS
	KEY ?DUP 0EXIT a>A SWITCH
	$20 CASE BREAK
	8   CASE 1 FRAME- BREAK
	$0D CASE CLRSCR BREAK
	'F' CASE ' VIEW-FRAME W@ ' VIEWF 1+ <> IF ' VIEWF ELSE ' VIEWN THEN 1+ ' VIEW-FRAME W! CLRSCR BREAK
	'H' CASE ' VIEWH 1+ ' VIEW-FRAME W! BREAK
	'-' CASE skips C~ wspd C++ BREAK
	'+' CASE wspd C@ 1 = IF skips C++ ELSE wspd C@ 1 > IF wspd C-- THEN THEN BREAK
	'=' CASE 1 wspd W! BREAK
	'<' CASE 90 FRAME- BREAK
	'>' CASE 90 FRAME+ BREAK
	'\' CASE 0 0 BOUNCE BREAK
	'|' CASE 0 0 BOUNCE !WIN CLRSCR BREAK
	'[' CASE -1 vbounce +! -1 hbounce +! BREAK
	']' CASE 1 vbounce +! 1 hbounce +! BREAK
	;

	*** watch a BMV bit-map video ***

pre WATCH ( name -- )
	GET$ DUP BMV$ $! " .BMV" OPEN-EXT$
pub REPLAY
---	init frame count and brightness
	vcnt ~   100 LUMA
---	exit no file 	clear screen and reset window bouncing
	@FILE 0EXIT		CLRSCR 0 0 BOUNCE
---	scan * calculate frame size sectors
	0 SD@ 0 BEGIN 512 + DUP SD@ 3RD = UNTIL 9>> AT BSECTS :=! DROP
---	Read x and y resolution using first frame
	$12 SDW@ AT XRES :=!   $16 SDW@ AT YRES :=!
---	reset speed and frame number = sector
	1 wspd W! @FILE frame !
	BMV$ TRACK$
pub RESUME ( 37ms @250MHz to load and view a frame )
	BEGIN
	  LOAD-FRAME \ ?WAVE ( 8,163,816 cycles= 27,212,720ns @300MHz ok ) ( vsync ~ 1.47ms )
---	check for end of file (assumes next sector is not a bmp!)
	  BMVBUF W@ $4D42 = KEY@ >B $1B <> AND
	WHILE
---	FRAME SYNCH
	  wspd C@ vcnt W@ + >W BEGIN ( ?WAVE ) DUP vcnt W@ = UNTIL DROP
	  VIEW-FRAME ( 1,231,944 cycles= 4,927,776ns @250MHz ok )
	  ?WAVE
---	  go or skip to next frame
	  skips C@ 1+ FRAME+
	  ?MEDIA-KEYS
	REPEAT
	wavsz ~ STOP
	;


\ : REPORT frmcnts 4 + @ frmcnts 8 + 2000 ADO I @ DUP ROT - . SPACE 4 +LOOP ;



(		SOME DEMO WORDS 	)

{
pub SLIDESHOW ( frames -- )
	1 MAX 600 MIN
	BEGIN
	0
	  BEGIN
	    ROOT DUP SDC@ KEY 0= AND
	  WHILE
	    DUP 8 + SD@ 24 BITS " BMP" @ = IF DUP SDADR D>S VIEWSEC OVER FRAMES THEN
	    32 +
	  REPEAT
	  DROP
	  KEY
	UNTIL DROP
	;
}



--- adjust pen and paper for best black and white
: -BEST
	0 0 256 0 DO I 4* PAL + @ RGB> + + 2DUP < IF -ROT 2DROP I SWAP ELSE DROP THEN LOOP DROP PEN
	0 $FFFFFF 256 0 DO I 4* PAL + @ RGB> + + 2DUP > IF -ROT 2DROP I SWAP ELSE DROP THEN LOOP DROP PAPER
	;

--- draw a button
: BUTTON ( width height -- )
	2DUP RECT !XY 1 X+! 1 Y+! XY@! 2DUP 2- SWAP 2- SWAP RECT
	!XY 3 X+! 3 Y+! XY@! 8 - SWAP 8 - SWAP PANEL
	;
\ 100 100 @XY 100 50 BUTTON


: COLORS			PAL 1024 ;

: PALMASK ( mask -- )		COLORS ADO I @ OVER AND I ! 4 +LOOP DROP ;

: SHADOWS ( val -- )		COLORS ADO I @ RGB> 3 FOR 4TH OVER > IF DROP 0 THEN ROT NEXT >RGB I ! 4 +LOOP DROP ;

: N
: NEGATIVE			COLORS ADO I @ NOT I ! 4 +LOOP ;

byte gam*
byte gam/
byte _th

--- simple gamma routine
pub GAMMA ( gamma* gamma/ thresh< -- )
	_th C! gam/ C! gam* C!
	PAL $400 ADO
	  I @ RGB> ( split into components )
	  3 FOR DUP _th C@ < IF gam* C@ gam/ C@ */ THEN ROT NEXT
	  >RGB I ! ( recombine rgb and update )
	4 +LOOP DROP
	;


pub SUBS	( old new -- )		COLORS ADO OVER I @ = IF I ! LEAVE THEN 4 +LOOP DROP ;















		*** VGA BITMAP TEXT ***

pub *TEXT*	PRINT" VGA BMP TEXT 190800-0000" ;

private
100 7 * TABLE FONT5X7

--- User commands to change line and character spacing
pub LSP ( n -- )	>!
pri lsp			10 ; --- line space constant'
pub CSP ( n -- )	>!
pri csp			6 ; --- character space constant

private
long col	--- character column pixel
long row	--- character row line

byte vflg	--- 0= noscroll
byte _scrolls

--- bytes/line of text
pri b/l ( -- bytes )	cols lsp W* 3 >> BPP@ * ;


--- setup _scr to point to screen at current row and column
\ pri @RC 			col @ row @ cols W* + SCR + scr* ! ;
\ pri @FONT ( ascii -- chadr ) 	>B $20 - 7 * FONT5X7 + ;


pub VXY    ( x y -- )	row ! col ! ;

long col1
long row1
pub VXY>		col1 @ row1 @ VXY ;
pub >VXY		col @ col1 ! row1 @ row1 ! ;

pub BOTTOM		0 rows lsp - VXY ;

--- Set how many rows the terminal will use where 0 = all
pub NS
	0
pub TERM ( lines -- )
	rows lsp / MIN _scrolls C!
	0 rows lsp - VXY csp 1- AT lm C!
	;

pri VHOME
	0 TERM 0 0 VXY rows lsp / _scrolls C!
	;


pri NEWLINE
	lm col !
	lsp row +!
	row @ lsp 1- + rows => 0EXIT
pri VSCROLL
	_scrolls C@
	IF SCR scrsz + b/l _scrolls C@ W* - DUP b/l + SWAP b/l _scrolls C@ 1- W* 4/ LMOVE THEN
	SCR scrsz + b/l - b/l PAPER@ FILL
	lsp NEGATE row +!
	;




pri FONTGEN ( ch -- font )	$1C - 7 W* FONT5X7 + ;
pri CHAR++			csp col +! ;

	*** DRAW CHARACTERS ***

{
code PLOTCH1 ' ( x y --  ) '
	rdword	xx,#@cols 2+
	shr	xx,#3
	mul	a,xx		' a = cols W* >> 3 '
	rdlong	xx,#@SCR 2+
	add	a,xx
	mov	xx,b		' x '
	shr	xx,#3		' x >>3'
	add	a,xx		' a = scrptr
	rdbyte	xx,a		' read byte'
	and	b,#7		' bit position in byte '
	mov	c,c wz
 	bitnz	xx,b
 _ret_	wrbyte	xx,a
	end
}

--- Display the VGA character and update position etc 1 BPP
pub VCH1 ( ch -- )
	FONTGEN
     7 ADO col @ row @ @XY I C@
       5 FOR DUP 1& IF PEN@ X@ Y@ PLOT1 THEN _x ++ 2/ NEXT
     DROP row W++ LOOP
     -7 row W+! CHAR++
     ;

{
5 FOR DUP 1& IF PEN@ X@ Y@ PLOT1 THEN _x ++ 2/ NEXT
code PLOT1 ' ( pen x y --  ) '
	rdword	xx,#@cols 2+
	shr	xx,#3
	mul	a,xx		' a = cols W* >> 3 '
	rdlong	xx,#@SCR 2+
	add	a,xx
	mov	xx,b		' x '
	shr	xx,#3		' x >>3'
	add	a,xx		' a = scrptr
	rdbyte	xx,a		' read byte'
	and	b,#7		' bit position in byte '
	mov	c,c wz
z 	bitnz	xx,b
 	wrbyte	xx,a
 	3DROP;
	end

\ PEN@ _x _y
pub VCH1

code PLOT1X ' ( pen x y --  ) '
	rdword	xx,#@cols 2+
	shr	xx,#3
	rdword	yy,#@_y
	mul	yy,xx		' a = cols W* >> 3 '
	rdlong	xx,#@SCR 2+
	add	zz,xx
	mov	xx,b		' x '
	shr	xx,#3		' x >>3'
	add	a,xx		' a = scrptr
	rdbyte	xx,a		' read byte'
	and	b,#7		' bit position in byte '
	mov	c,c wz
 	bitnz	xx,b
 _ret_ 	wrbyte	xx,a

	end

}


{ LAP VCH1 LAP .LAP --- 32,568 cycles= 95,788ns @340MHz ok
$41 LAP VCH1 LAP .LAP --- 32,088 cycles= 94,376ns @340MHz ok

pri X@			_x W@ ;
pri Y@			_y W@ ;

pub x			DUP _x W! _x1 W! ;
pub y			DUP _y W! _y1 W! ;

}


pub VCH2 ( ch -- )
	FONTGEN
---	   set cursor  - read font row - each bit
     7 ADO col @ row @ @XY I C@ 5 FOR DUP 1& IF PEN@ PIXEL! THEN _x ++ 2/ NEXT DROP row W++ LOOP
     -7 row W+!
     CHAR++
     ;
pub VCH4
	FONTGEN DROP
	;

\ DRAW 5x7 VIDEO CHARACTER'
\ WRCH ( font screen pen.paper )'
1 @VGA := _hp

code VCH8A
		setq	#20		  	' copy into cogmod memory'
		rdlong	@COGMOD,#PC 12 +  'read longs into cog'
		jmp		#\@COGMOD	' and run it there'
		' this section is loaded and run in cog memory '
		mov		PTRA,b
		mov		b,a
		shr		b,#8		' b = pen, a = paper'
		rdlong	r2,#_hp		' _hpixels
		sub		r2,#6
		mov		r1,#7
.l1		rdbyte	xx,c		' read in next font char
		rep		#3,#5
	 	shr		xx,#1 wc
 if_c	wrbyte	b,ptra++	' PEN PIXEL '
 if_nc	wrbyte	a,ptra++	' PAPER PIXEL '
		wrbyte	a,ptra++	' + BLANK COLUMN '
		add		PTRA,r2		' next line'
		add		c,#1
 _ret_	djnz	r1,#l1
		end

pub VCH8 ( ch -- )
	FONTGEN
	col @ row @ cols W* + SCR +
	PAPER@ ( font' screen' pen.paper  -- )
	VCH8A
	3DROP CHAR++
	;


{
ASSEMBLER
pub EXIT:	PTRA $00BC CALLDS, end [C] ] ;


pub VCH8X ( ch -- )
	FONTGEN
	col @ row @ cols W* + SCR +
	PAPER@ ( font' screen' pen.paper  -- )
	ASM:
		'setq	#20			' copy into cogmod memory'
		'rdlong	@COGMOD,#PC 12 +	'read longs into cog'
		'jmp	#\@COGMOD		' and run it there'
		''
		mov	PTRA,b
		mov	b,a
		shr	b,#8			' b = pen, a = paper'
		rdlong	r2,#_hp			' _hpixels
		sub	r2,#6
		mov	r1,#7
.l1		rdbyte	xx,c			' read in next font char
		rep	#3,#5
		 shr	xx,#1 wc
  	if_c	 wrbyte	b,ptra++		' PEN PIXEL '
	if_nc	 wrbyte	a,ptra++		' PAPER PIXEL '
		wrbyte	a,ptra++		' + BLANK COLUMN '
		add	PTRA,r2			' next line'
		add	c,#1
		djnz	r1,#l1

	FORTH:
		3DROP CHAR++
		;

!VGA -VGA -TERM CLRSCR VHOME
}


--- Display the 5x7 VGA character and update position etc
pub VCH ( char -- ) --- 8.750us @300MHZ
	col @ rm => IF NEWLINE THEN
	BPP@ SWITCH
	1 CASE VCH1 BREAK	--- 45,658 cycles= 152,193ns @300MHz ok
	2 CASE VCH2 BREAK
	4 CASE VCH4 BREAK
	VCH8			--- 4,690 cycles= 15,633ns @300MHz ok
	;
word vcold

--- make the VGA display the current output device
pub VGA
    vcold W@ $A55A <> IF 100:100 vint W! -MONO VHOME CLRSCR $A55A vcold W! THEN
    EMIT:
pub VEMIT ( ch -- )
    DUP 32 <
    IF
    SWITCH
      $00 CASE BREAK
      $01 CASE VHOME BREAK
\      $07 CASE BELL BREAK
      $08 CASE col @ lm <> IF csp NEGATE col +! THEN BREAK
      $09 CASE  BEGIN 32 VCH col @ csp / 7 AND 0= UNTIL BREAK
      $0A CASE NEWLINE BREAK
      $0C CASE CLRSCR VHOME BREAK
      $0D CASE lm col ! BREAK
\      $1B CASE 2 vflg SET BREAK                    --- ESC will accept next byte as data
 \     $10 $17 CASES SWITCH@ HUE BREAK        --- codes $10..$17 select a color
\     $18 CASE $80 vflg CLR BREAK                --- wrap
\     $19 CASE $80 vflg SET BREAK                --- no word wrap
\    1 vflg CLR
\      CASE@ REVERSE -2 row W+! .BYTE 2 row W+! REVERSE EXIT
\	CASE@ ( unknown control - display as character )
	EXIT
    THEN
    VCH
    ;

{
200318:
LAP $41 VEMIT LAP .LAP --- 84,368 cycles= 248,141ns @340MHz ok
Fix BPP@
LAP $41 VEMIT LAP .LAP --- 79,824 cycles= 234,776ns @340MHz ok
Fix rows cols
LAP $41 VCH LAP .LAP --- 68,681 cycles= 202,002ns @340MHz ok

code plot
LAP $41 VCH LAP .LAP --- 52,689 cycles= 154,967ns @340MHz ok

}










	*** temporary font generator ***

pub CH
	$1C -
	7 W* FONT5X7 + SWAP ( adr str ) 1+
	7 FOR
	 0 OVER 5 ADO 2* I C@ 1& OR LOOP ( adr str val )
	 REV 27 >>
	 3RD C! ( adr str ) 5 + b++
	NEXT
	2DROP
	;


{ 5X7 FONT TABLE
7 bytes of 5 bit rows
available control "chars" 02 03 04 05 06 0B 0E 0F 10..1F
}

"  10101101011010110101101011010110101" $1C CH "  01011010110101101011010110101101010" $1D CH
"  11111000001111100000111110000011111" $1E CH "  01010101010101010101010101010101010" $1F CH
				*** SYMBOLS ***
"  00000000000000000000000000000000000" $20 CH "  00100001000010000100001000000000100" $21 CH
"  01010010100101000000000000000000000" $22 CH "  01010010101111101010111110101001010" $23 CH
"  00100011111010001110001011111000100" $24 CH "  11000110010001000100010001001100011" $25 CH
"  01100100101010001000101011001001101" $26 CH "  01100001000100000000000000000000000" $27 CH
"  00010001000100001000010000010000010" $28 CH "  01000001000001000010000100010001000" $29 CH
"  00000001001010101110101010010000000" $2A CH "  00000001000010011111001000010000000" $2B CH
"  00000000000000000000011000010001000" $2C CH "  00000000000000011111000000000000000" $2D CH
"  00000000000000000000000000110001100" $2E CH "  00000000010001000100010001000000000" $2F CH
				*** DIGITS ***
"  01110100011001110101110011000101110" '0' CH "  00100011000010000100001000010001110" '1' CH
"  01110100010000100010001000100011111" '2' CH "  11111000100010000010000011000101110" '3' CH
"  00010001100101010010111110001000010" '4' CH "  11111100001111000001000011000101110" '5' CH
"  00110010001000011110100011000101110" '6' CH "  11111100010000100010001000010000100" '7' CH
"  01110100011000101110100011000101110" '8' CH "  01110100011000101111000010001001100" '9' CH
"  00000011000110000000011000110000000" $3A CH "  00000011000110000000011000010001000" $3B CH
"  00010001000100010000010000010000010" $3C CH "  00000000001111111111000000000000000" $3D CH
"  01000001000001000001000100010001000" $3E CH "  01110100010000100010001000000000100" '?' CH

				*** UPPER CASE ***
\ "  01110100010000101101101011010101110" $40 CH
"  01110101011010110110100001000101110" $40 CH "  01110100011000110001111111000110001" 'A' CH
"  11110100011000111110100011000111110" 'B' CH "  01110100011000010000100001000101110" 'C' CH
"  11100100101000110001100011001011100" $44 CH "  11111100001000011110100001000011111" 'E' CH
"  11111100001000011110100001000010000" $46 CH "  01110100011000010111100011000101111" 'G' CH
"  10001100011000111111100011000110001" $48 CH "  01110001000010000100001000010001110" 'I' CH
"  00111000100001000010000101001001100" $4A CH "  10001100101010011000101001001010001" 'K' CH
"  10000100001000010000100001000011111" $4C CH "  10001110111010110101100011000110001" 'M' CH
"  10001100011100110101100111000110001" $4E CH "  01110100011000110001100011000101110" 'O' CH
"  11110100011000111110100001000010000" $50 CH "  01110100011000110001101011001001101" 'Q' CH
"  11110100011000111110101001001010001" $52 CH "  01111100001000001110000010000111110" 'S' CH
"  11111001000010000100001000010000100" $54 CH "  10001100011000110001100011000101110" 'U' CH
"  10001100011000110001100010101000100" $56 CH "  10001100011000110101101011010101010" 'W' CH
"  10001100010101000100010101000110001" $58 CH "  10001100011000101010001000010000100" 'Y' CH
"  11111000010001000100010001000011111" $5A CH "  11100100001000010000100001000011100" $5B CH
"  10000100000100000100000100000100001" $5C CH "  00111000010000100001000010000100111" $5D CH
"  00100010101000100000000000000000000" $5E CH "  00000000000000000000000000000011111" $5F CH

				*** LOWER CASE ***
"  01000001000001000000000000000000000" $60 CH "  00000000000111000001011111000101110" 'a' CH
"  10000100001011011001100011000111110" $62 CH "  00000000000111010000100001000101110" 'c' CH
"  00001000010110110011100011000101111" $64 CH "  00000000000111010001111111000001110" 'e' CH
"  00110010010100011110010000100001000" $66 CH "  00000011111000110001011110000101110" 'g' CH
"  10000100001011011001100011000110001" $68 CH "  00100000000110000100001000010001110" 'i' CH
"  00010000000001000010000101001001100" $6A CH "  10000100001001010100110001010010010" 'k' CH

"  00000011000010000100001000010001110" $6C CH "  00000000000101010101101011010110101" 'm' CH
"  00000000001011010001100011000110001" $6E CH "  00000000000011001001010010100100110" 'o' CH
"  00000000001011011001100011111010000" $70 CH "  00000000000110110011011110000100001" 'q' CH
"  00000000001011011001100001000010000" $72 CH "  00000000000111010000011100000111110" 's' CH
"  00000001000111100100001000010000010" $74 CH "  00000000001000110001100011000101110" 'u' CH
"  00000000001000110001010100101000100" $76 CH "  00000000001010110101101011010101010" 'w' CH
"  00000000001000101010001000101010001" $78 CH "  00000100011000110001011110000101110" 'y' CH
\ "  00000000001000110001010100010001100" 'y' CH
"  00000000001111100010001000100011111" $7A CH "  00110001000010011000001000010000110" $7B CH
"  00100001000010000100001000010000100" $7C CH "  01100001000010000011001000010011100" $7D CH
"  00000000000101010100000000000000000" $7E CH "  11111111111111111111111111111111111" $7F CH


FORGET CH ( remove compile helper )



{

font5x7 $20 7 * + 96 7 * DUMP

--- dump font in csv hex byte form
font5x7 $20 7 * + 96 7 * ADO CRLF I 7 ADO I C@ .B ." ," LOOP 8 EMIT $20 EMIT 7 +LOOP

}
pub CONVGA		EMIT: DUP CONEMIT VEMIT ;


--- Set P2 EVAL audio pins
: P2EVAL		7 AT ROUT :=!   6 AT LOUT :=! ;
vcold W~

{
1 BPP 720p CLRSCR
100 w 100 h  50 50 ADO I 1& IF  I x I y RECT THEN LOOP


VIEW SCR ON TERMINAL
OFF %CURSOR CLS SCR 200 FOR 640 FOR DUP I+ C@ 7 AND 7 XOR %PEN '*' CONEMIT NEXT CRLF 640 + NEXT DROP 7 %PEN

OFF %CURSOR CLS SCR 200 FOR 640 FOR DUP I+ C@ 7 AND DUP 7 = IF %BOLD ELSE %PLAIN THEN 0 XOR %PEN '*' CONEMIT NEXT CRLF 640 + NEXT DROP 7 %PEN

}

END
